﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;
using Azyobuzi.りすにんぐついったー.Properties;

namespace Azyobuzi.りすにんぐついったー
{
    public partial class AuthForm : Form
    {
        public AuthForm()
        {
            InitializeComponent();
            this.Icon = Resources.mainIco;
            this.DialogResult = DialogResult.Cancel;
            this.Move += (sender, e) => ((Control)sender).Refresh();
        }

        private void titleLbl_Paint(object sender, PaintEventArgs e)
        {
            var sender2 = (Label)sender;
            using (LinearGradientBrush g=new LinearGradientBrush(sender2.Bounds,Color.LightBlue,Color.Blue,LinearGradientMode.Vertical)) {
                e.Graphics.FillRectangle(g, sender2.Bounds);
                StringFormat sf = new StringFormat();
                sf.Alignment = StringAlignment.Center;
                sf.LineAlignment = StringAlignment.Center;
                e.Graphics.DrawString(sender2.Text, sender2.Font, Brushes.WhiteSmoke, sender2.Bounds, sf);
                sf.Dispose();
            }
        }

        #region http://dobon.net/vb/dotnet/form/moveform.html より
        private Point mousePoint;

        private void titleLbl_MouseDown(object sender, MouseEventArgs e)
        {
            if ((e.Button & MouseButtons.Left) == MouseButtons.Left)
            {
                //位置を記憶する
                mousePoint = new Point(e.X, e.Y);
            }
        }

        private void titleLbl_MouseMove(object sender, MouseEventArgs e)
        {
            if ((e.Button & MouseButtons.Left) == MouseButtons.Left)
            {
                this.Left += e.X - mousePoint.X;
                this.Top += e.Y - mousePoint.Y;
            }
        } 
        #endregion

        private void AuthForm_Paint(object sender, PaintEventArgs e)
        {
            Rectangle rect = new Rectangle(0, this.label1.Height, this.Width - 1, this.Height - this.label1.Height - 1);
            e.Graphics.DrawRectangle(Pens.Gray, rect);
        }

        private void cancelBtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void okBtn_Click(object sender, EventArgs e)
        {
            if (!Program.ExistsChar(textBox1.Text))
            {
                MessageBox.Show(
                    "Twitterの認証画面で表示される暗証番号を入力してください。拒否した場合は[Cancel]をクリックしてください。",
                    "入力エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);

                return;
            }

            var httpCon = Program.httpCon;
            if (!httpCon.AuthenticatePinFlow("https://api.twitter.com/oauth/access_token", req, textBox1.Text))
            {
                MessageBox.Show("暗証番号が正しくありません。", "認証エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            var s = SettingsXml.Instance;
            s.accessToken = httpCon.AccessToken;
            s.accessTokenSecret = httpCon.AccessTokenSecret;

            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        string req = "";

        private void AuthForm_Shown(object sender, EventArgs e)
        {
            Application.DoEvents();
            var httpCon = Program.httpCon;
            Uri url=null;
            httpCon.AuthenticatePinFlowRequest("https://api.twitter.com/oauth/request_token", "https://api.twitter.com/oauth/authorize", ref req, ref url);
            System.Diagnostics.Process.Start(url.ToString());
        }
    }
}
