﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using Azyobuzi.りすにんぐついったー.Properties;

namespace Azyobuzi.りすにんぐついったー
{
    public partial class SettingsForm : Form
    {
        public SettingsForm()
        {
            InitializeComponent();
            this.Icon = Resources.mainIco;
            this.DialogResult = DialogResult.Cancel;
            this.Move += (sender, e) => ((Control)sender).Refresh();

            //設定読み込み
            var s = SettingsXml.Instance;
            intervalBox.Value = s.interval;
            tempBox.Text = s.template;
        }

        private void titleLbl_Paint(object sender, PaintEventArgs e)
        {
            var sender2 = (Label)sender;
            using (LinearGradientBrush g = new LinearGradientBrush(sender2.Bounds, Color.LightBlue, Color.Blue, LinearGradientMode.Vertical))
            {
                e.Graphics.FillRectangle(g, sender2.Bounds);
                StringFormat sf = new StringFormat();
                sf.Alignment = StringAlignment.Center;
                sf.LineAlignment = StringAlignment.Center;
                e.Graphics.DrawString(sender2.Text, sender2.Font, Brushes.WhiteSmoke, sender2.Bounds, sf);
                sf.Dispose();
            }
        }

        private void SettingsForm_Paint(object sender, PaintEventArgs e)
        {
            Rectangle rect = new Rectangle(0, this.label1.Height, this.Width - 1, this.Height - this.label1.Height - 1);
            e.Graphics.DrawRectangle(Pens.Gray, rect);
        }

        #region http://dobon.net/vb/dotnet/form/moveform.html より
        private Point mousePoint;

        private void titleLbl_MouseDown(object sender, MouseEventArgs e)
        {
            if ((e.Button & MouseButtons.Left) == MouseButtons.Left)
            {
                //位置を記憶する
                mousePoint = new Point(e.X, e.Y);
            }
        }

        private void titleLbl_MouseMove(object sender, MouseEventArgs e)
        {
            if ((e.Button & MouseButtons.Left) == MouseButtons.Left)
            {
                this.Left += e.X - mousePoint.X;
                this.Top += e.Y - mousePoint.Y;
            }
        }
        #endregion

        private void authBtn_Click(object sender, EventArgs e)
        {
            var auth = new AuthForm();
            auth.ShowDialog();
            auth.Dispose();
        }

        private void cancelBtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void okBtn_Click(object sender, EventArgs e)
        {
            if (!Program.ExistsChar(tempBox.Text))
            {
                MessageBox.Show("投稿内容を入力してください。","入力エラー",MessageBoxButtons.OK,MessageBoxIcon.Error);
                return;
            }
            
            var s = SettingsXml.Instance;
            s.interval = (uint)intervalBox.Value;
            s.template = tempBox.Text;

            this.DialogResult = DialogResult.OK;
            this.Close();
        }
    }
}
